// Veranschaulichung der Lebenszyklen von Objekten
#include <iostream>
using namespace std;

int objid = 0;			// eindeutige Objektid / Anzahl erzeugter Obj.

class student {
	char *name;
	long matrikelnr;
	int id;
public:
	student(char *init="", long m=0l)
	{
		name = new char[strlen(init)+1]; strcpy(name, init);
		matrikelnr = m;
		id = ++objid ;	// Nummer des erzeugten Objekts
		cout << "erzeuge Student: "<< name << "(" << matrikelnr << ")" ;
		cout << " (Objekt Nr. "<<id<<")"<<endl;
	}
	~student()
	{
		cout << "loesche Student: "<< name << "(" << matrikelnr << ")" ;
		cout << " (Objekt Nr. "<<id<<")"<<endl;
		delete [] name;
	}
	student(student &);			// Der Kopierkonstruktor
	student &operator=(student &);		// Der Zuweisungsoperator

	void showyourname() const		// Methode aendert Obj NICHT!
	{
		cout << "Hallo ich bin "<<name<<" ("<<matrikelnr<<")"<<endl;
		cout << "(Das sagte Objekt Nr. "<<id<<")"<<endl;
	}
};

student::student(student &a)		// Kopierkonstruktor
{
	name = new char[strlen(a.name)+1]; strcpy(name, a.name);
	matrikelnr = a.matrikelnr;   
	cout << "Kopierkonstruktor called for "<<name<<" id="<<a.id<<endl;
	id = ++objid;
	cout << "Kopierkonstruktor: Habe Obj Nr "<<id<<" initialisiert!"<<endl;
}

student &student::operator=(student &a)	// Zuweisungsoperator
{	if (name)	delete [] name;		// alten Inhalt ggf. freigeben
	name = new char[strlen(a.name)+1]; strcpy(name, a.name);
	matrikelnr = a.matrikelnr;
	cout << "Zuweisungsoperator called for "<<name<<" id="<<a.id<<endl;
	return *this;
}

void fkt(student person) 
{
	cout <<"** in fkt - vor showyourname"<<endl;
	person.showyourname();
	cout << "** Ende von fkt"<<endl;
}

int main()
{	student karl("karl", 523312);
	student hans("hans", 52312);

	cout <<"** fkt(hans)"<<endl;
	fkt(hans);
	cout <<"** vor hans = karl"<<endl;
	hans = karl;
	cout <<endl<<"Es wurden "<<objid<<" Objekte insgesamt erzeugt."<<endl;
	cout << "So: Jetzt wird main beendet. Wurde auch Zeit!"<<endl<<endl;;
}
