// generic stack template
// supported operations are:
// newStack(), deleteStack; push() and pop() as well as isEmpty()
#ifndef __STACK_H			// don't include module twice
#define __STACK_H

#include <stdlib.h>			// needed for malloc

namespace stack {

template <class T>
struct Stack {
	Stack *next;			// next stack element or null
	T element;			// content template
};

template <class T>			// nice: s is reference to a pointer :-)
void newStack(Stack<T> *&s) {		// create new stack manager
	s = NULL;
}

template <class T>
void deleteStack(Stack<T> *&s) {	// delete complete stack recursively
	if (s != NULL) {
		deleteStack(s->next);
		free(s);
		s = NULL;
	}
}

template <class T>
int isEmpty(Stack<T> *&s) {		// check for empty stack
	return s == NULL;
}

template <class T>
void push(Stack<T> *&s, T element) {	// operation push: add an element
	Stack<T> *elem = (Stack<T>*) malloc(sizeof(Stack<T>));

	if (!elem)
		throw "no more space in push ...";

	elem->next = s;
	elem->element = element;

	s = elem;
}

template <class T>
T pop(Stack<T> *&s) {			// operation pop: get newest element
	if (!isEmpty(s)) {
		Stack<T> *elem = s;
		s = elem->next;
		T element = elem->element;
		free(elem);
		return element;
	}
	throw "error: pop on empty stack ...";
}

}		// end namespace stack
#endif
